
// ----------------------------------------------------------------------

void DemoMove_Bow() {
  // bow movement used to introduce demo move
  SetLedMode(1);
  MoveToAngles(90,LegDn,90,LegDn,90,LegDn,90,LegDn);
  GoToAngles(45,120,45,120,90,90,90,90,50); loopWhiletgtCnt();
  GoToAngles(90,173,90,173,-1,-1,-1,-1,60); loopWhiletgtCnt();
  delayLoop(1000); // pause
  GoToAngles(45,120,45,120,-1,-1,-1,-1,30); loopWhiletgtCnt();
  GoToAngles(90,90,90,90,-1,-1,-1,-1,30); loopWhiletgtCnt();
  SetLedMode(0);
}

// ----------------------------------------------------------------------

void DemoMove_SitNWave() {
  // sit and wave the right hand
  SetLedMode(1);
  MoveToAngles(90,LegDn,90,LegDn,90,LegDn,90,LegDn);
  GoToAngles(90,90,90,90,145,145,145,145,50); loopWhiletgtCnt();
  LedMode = 0; delayLoop(1000); // pause
  LedMode = 1; GoToAngles(90,90,80,160,145,145,145,145,20); loopWhiletgtCnt();
  LedMode = 0; delayLoop(200); SetLedMode(4); // pause
  for (anyFor=0; anyFor<2; anyFor++) {
    GoToAngles(90,90,60,180,145,145,145,145,3); loopWhiletgtCnt();
    GoToAngles(90,90,40,150,145,145,145,145,3); loopWhiletgtCnt();
    delayLoop(100); // pause
    GoToAngles(90,90,60,180,145,145,145,145,3); loopWhiletgtCnt();
    GoToAngles(90,90,80,150,145,145,145,145,3); loopWhiletgtCnt();
    delayLoop(100); // pause
  }
  LedMode = 0; delayLoop(1000); // pause
   SetLedMode(3); GoToAngles(90,90,90,90,145,145,145,145,50); loopWhiletgtCnt();
  LedMode = 0; delayLoop(1000); // pause
   SetLedMode(3);GoToStand(50); loopWhiletgtCnt();
  LedMode = 0;
}

// ----------------------------------------------------------------------

void GoToAngles(int zA1,int zA2,int zA3,int zA4,int zA5,int zA6,int zA7,int zA8, int zCnt) {
  // move to specific servo angles, or -1 means no change
  // number of 20ms steps in movement set by zCnt
  if (ESC) return; // exit if this flag is set
  if (!servoEn) {attachServos(0);}
  if (zA1 >= 0) {servoTgt[0] = map(zA1,45,135,Ang1_45,Ang1_135);}
  if (zA2 >= 0) {servoTgt[1] = map(zA2,65,153,Ang2_65,Ang2_153);}
  if (zA3 >= 0) {servoTgt[2] = map(zA3,45,135,Ang3_45,Ang3_135);}
  if (zA4 >= 0) {servoTgt[3] = map(zA4,65,153,Ang4_65,Ang4_153);}
  if (zA5 >= 0) {servoTgt[4] = map(zA5,45,135,Ang5_45,Ang5_135);}
  if (zA6 >= 0) {servoTgt[5] = map(zA6,65,153,Ang6_65,Ang6_153);}
  if (zA7 >= 0) {servoTgt[6] = map(zA7,45,135,Ang7_45,Ang7_135);}
  if (zA8 >= 0) {servoTgt[7] = map(zA8,65,153,Ang8_65,Ang8_153);}
  checkTgts(); // ensure target values are within limits
  tgtCnt = zCnt;
//  Serial.println(F("GoToAngles Set"));
//  Serial.println(tgtCnt);
}

// ----------------------------------------------------------------------

void GoToRest(int zCnt) {
  // move to the resting position
  // number of 20ms steps in movement set by zCnt
  if (ESC) return;
//  Serial.println(F("> GoToRest()"));
  GoToAngles(65,65,65,65,65,65,65,65,zCnt); // go to the resting position
  autoRest = autoRestMax; // no need to rest from this position
}

// ----------------------------------------------------------------------

void GoToStand(int zCnt) {
  // move to the normal standing position
  // number of 20ms steps in movement set by zCnt
  if (ESC) return;
//  Serial.println(F("> GoToStand()"));
  GoToAngles(90,90,90,90,90,90,90,90,zCnt); // go to the resting position
  autoRest = autoRestMax; // no need to rest from this position
}

// ----------------------------------------------------------------------

void JoyMoveBwd() {
  // called from main loop to respond to joystick demands
  // this function walks and steers in a backwards direction
  WalkLftDrive = 128; WalkRgtDrive = 128;
  if (Walk == 0) {
    // the start of a new walk movement
    if (WalkLast != 3) {
      // previously walking in a different direction
//      Serial.println(F("Walking Backwards"));
      walkInterval = 60000; StartWalk(3);
    } else {
      // continue walking in same direction
      SetLegsPrevious(); Walk = WalkLast;
    } JoyYi = 0; JoyYT = true; SetLedMode(3);
  } else {
    // ensure joystick values are in the required range
    if (JoyX < 127) {JoyXV = 128 - JoyX;} // convert -ve vector to +ve
    else {JoyXV = JoyX - 127;} // ensure JoyX = 0 - 128
    if (JoyY < 128) {JoyYV = 128 - JoyY;} // convert -ve vector to +ve
    else {JoyYV = JoyY - 127;} // ensure JoyY = 0 - 128
    JoySpd = JoyYV; if (JoyXV > JoyYV) {JoySpd = JoyXV;}
    // we use the larger of the two joystick values to set the speed
    // JoyYi is a tracking filter to slug the initial joystick response
    if (JoyYT) {
      // initially slug the response until it catches up
      if (JoyYi < (JoySpd-2)) {JoyYi += 2;}
      else if (JoyYi > (JoySpd+2)) {JoyYi -= 2;}
      else {JoyYi = JoySpd; JoyYT = false;}
    } else {JoyYi = JoySpd;}
    walkInterval = map((unsigned long)JoyYi,0,128,1,WalkMax);
    walkInterval = 60000/walkInterval;
    // now apply steering
    if (JoyX <= 127) {WalkLftDrive = JoyX + 1;}
    else {WalkRgtDrive = 127-(JoyX-128);}
    if ((WalkSpeed == 1) && (C_Dn == 25)) {
      // 'C' held during walking
      LegUpFwd = LegUpMax; WalkLftDrive /= 2; WalkRgtDrive /= 2;
    } else {
      LegUpFwd = LegUpMin;
    }
  }
}

// ----------------------------------------------------------------------

void JoyMoveFwd() {
  // called from main loop to respond to joystick demands
  // this function walks and steers in a backwards direction
  WalkLftDrive = 128; WalkRgtDrive = 128;
  if (Walk == 0) {
    // the start of a new walk movement
    if (WalkLast != 1) {
      // previously walking in a different direction
//      Serial.println(F("Walking Forwards"));
      walkInterval = 60000; StartWalk(1);
    } else {
      // continue walking in same direction
      SetLegsPrevious(); Walk = WalkLast;
    } JoyYi = 0; JoyYT = true; SetLedMode(1);
  } else {
    // ensure joystick values are in the required range
    if (JoyX < 127) {JoyXV = 128 - JoyX;} // convert -ve vector to +ve
    else {JoyXV = JoyX - 127;} // ensure JoyX = 0 - 128
    if (JoyY < 128) {JoyYV = 128 - JoyY;} // convert -ve vector to +ve
    else {JoyYV = JoyY - 127;} // ensure JoyY = 0 - 128
    JoySpd = JoyYV; if (JoyXV > JoyYV) {JoySpd = JoyXV;}
    // we use the larger of the two joystick values to set the speed
    // JoyYi is a tracking filter to slug the initial joystick response
    if (JoyYT) {
      // initially slug the response until it catches up
      if (JoyYi < (JoySpd-2)) {JoyYi += 2;}
      else if (JoyYi > (JoySpd+2)) {JoyYi -= 2;}
      else {JoyYi = JoySpd; JoyYT = false;}
    } else {JoyYi = JoySpd;}
    walkInterval = map((unsigned long)JoyYi,0,128,1,WalkMax);
    walkInterval = 60000/walkInterval;
    // now apply steering
    if (JoyX <= 127) {WalkLftDrive = JoyX;}
    else {WalkRgtDrive = 127-(JoyX-128);}
    // now set leg up height if in lowest speed
    if ((WalkSpeed == 1) && (C_Dn == 25)) {
      // 'C' held during walking
      LegUpFwd = LegUpMax; WalkLftDrive /= 2; WalkRgtDrive /= 2;
    } else {
      LegUpFwd = LegUpMin;
    }
  }
}

// ----------------------------------------------------------------------

void JoyMoveLft() {
  // called from main loop to respond to joystick demands
  // this function walks and steers in a leftwards direction
  WalkLftDrive = 128; WalkRgtDrive = 128;
  if (Walk == 0) {
    // the start of a new walk movement
    if (WalkLast != 4) {
      // previously walking in a different direction
//      Serial.println(F("Walking Leftwards"));
      walkInterval = 60000; StartWalk(4);
    } else {
      // continue walking in same direction
      SetLegsPrevious(); Walk = WalkLast;
    } JoyYi = 0; JoyYT = true; SetLedMode(2);
  } else {
    // ensure joystick values are in the required range
    if (JoyX < 127) {JoyXV = 128 - JoyX;} // convert -ve vector to +ve
    else {JoyXV = JoyX - 127;} // ensure JoyX = 0 - 128
    if (JoyY < 128) {JoyYV = 128 - JoyY;} // convert -ve vector to +ve
    else {JoyYV = JoyY - 127;} // ensure JoyY = 0 - 128
    JoySpd = JoyYV; if (JoyXV > JoyYV) {JoySpd = JoyXV;}
    // we use the larger of the two joystick values to set the speed
    // JoyYi is a tracking filter to slug the initial joystick response
    if (JoyYT) {
      // initially slug the response until it catches up
      if (JoyYi < (JoySpd-2)) {JoyYi += 2;}
      else if (JoyYi > (JoySpd+2)) {JoyYi -= 2;}
      else {JoyYi = JoySpd; JoyYT = false;}
    } else {JoyYi = JoySpd;}
    walkInterval = map((unsigned long)JoyYi,0,128,1,WalkMax);
    walkInterval = 60000/walkInterval;
    // now apply steering set by y-axis
    if (JoyY <= 127) {WalkLftDrive = JoyY;}
    else {WalkRgtDrive = 127-(JoyY-128);}
    if ((WalkSpeed == 1) && (C_Dn == 25)) {
      // 'C' held during walking
      LegUpFwd = LegUpMax; WalkLftDrive /= 2; WalkRgtDrive /= 2;
    } else {
      LegUpFwd = LegUpMin;
    }
  }
}

// ----------------------------------------------------------------------

void JoyMoveRgt() {
  // called from main loop to respond to joystick demands
  // this function walks and steers in a rightwards direction
  WalkLftDrive = 128; WalkRgtDrive = 128;
  if (Walk == 0) {
    // the start of a new walk movement
    if (WalkLast != 2) {
      // previously walking in a different direction
//      Serial.println(F("Walking Rightwards"));
      walkInterval = 60000; StartWalk(2);
    } else {
      // continue walking in same direction
      SetLegsPrevious(); Walk = WalkLast;
    } JoyYi = 0; JoyYT = true; SetLedMode(4);
  } else {
    // ensure joystick values are in the required range
    if (JoyX < 127) {JoyXV = 128 - JoyX;} // convert -ve vector to +ve
    else {JoyXV = JoyX - 127;} // ensure JoyX = 0 - 128
    if (JoyY < 128) {JoyYV = 128 - JoyY;} // convert -ve vector to +ve
    else {JoyYV = JoyY - 127;} // ensure JoyY = 0 - 128
    // we use the larger of the two joystick values to set the speed
    JoySpd = JoyYV; if (JoyXV > JoyYV) {JoySpd = JoyXV;}
    // JoyYi is a tracking filter to slug the initial joystick response
    if (JoyYT) {
      // initially slug the response until it catches up
      if (JoyYi < (JoySpd-2)) {JoyYi += 2;}
      else if (JoyYi > (JoySpd+2)) {JoyYi -= 2;}
      else {JoyYi = JoySpd; JoyYT = false;}
    } else {JoyYi = JoySpd;}
    walkInterval = map((unsigned long)JoyYi,0,128,1,WalkMax);
    walkInterval = 60000/walkInterval;
    // now apply steering set by y-axis
    if (JoyY <= 127) {WalkRgtDrive = JoyY;}
    else {WalkLftDrive = 127-(JoyY-128);}
    if ((WalkSpeed == 1) && (C_Dn == 25)) {
      // 'C' held during walking
      LegUpFwd = LegUpMax; WalkLftDrive /= 2; WalkRgtDrive /= 2;
    } else {
      LegUpFwd = LegUpMin;
    }
  }
}

// ----------------------------------------------------------------------

void JoyTurnLft() {
  // called from main loop to respond to joystick demands
  // this function turns in a leftwards direction
  if (Walk == 0) {
    // the start of a new walk movement
    if (WalkLast != 5) {
      // previously walking in a different direction
//      Serial.println(F("Turning Left"));
      walkInterval = 60000; StartWalk(5);
    } else {
      // continue walking in same direction
      SetLegsPrevious(); Walk = WalkLast;
    } JoyYi = 0; JoyYT = true; SetLedMode(2);
  } else {
    // ensure joystick values are in the required range
    if (JoyX < 127) {JoyXV = 128 - JoyX;} // convert -ve vector to +ve
    else {JoyXV = JoyX - 127;} // ensure JoyXV = 0 - 128
    // we use the joystick value to set the speed
    JoySpd = JoyXV;
    // JoyYi is a tracking filter to slug the initial joystick response
    if (JoyYT) {
      // initially slug the response until it catches up
      if (JoyYi < (JoySpd-2)) {JoyYi += 2;}
      else if (JoyYi > (JoySpd+2)) {JoyYi -= 2;}
      else {JoyYi = JoySpd; JoyYT = false;}
    } else {JoyYi = JoySpd;}
    walkInterval = map((unsigned long)JoyYi,0,128,1,WalkMax);
    walkInterval = 60000/walkInterval;
  }
}

// ----------------------------------------------------------------------

void JoyTurnRgt() {
  // called from main loop to respond to joystick demands
  // this function turns in a rightwards direction
  if (Walk == 0) {
    // the start of a new walk movement
    if (WalkLast != 6) {
      // previously walking in a different direction
//      Serial.println(F("Turning Right"));
      walkInterval = 60000; StartWalk(6);
    } else {
      // continue walking in same direction
      SetLegsPrevious(); Walk = WalkLast;
    } JoyYi = 0; JoyYT = true; SetLedMode(4);
  } else {
    // ensure joystick values are in the required range
    if (JoyX < 127) {JoyXV = 128 - JoyX;} // convert -ve vector to +ve
    else {JoyXV = JoyX - 127;} // ensure JoyXV = 0 - 128
    // we use the joystick value to set the speed
    JoySpd = JoyXV;
    // JoyYi is a tracking filter to slug the initial joystick response
    if (JoyYT) {
      // initially slug the response until it catches up
      if (JoyYi < (JoySpd-2)) {JoyYi += 2;}
      else if (JoyYi > (JoySpd+2)) {JoyYi -= 2;}
      else {JoyYi = JoySpd; JoyYT = false;}
    } else {JoyYi = JoySpd;}
    walkInterval = map((unsigned long)JoyYi,0,128,1,WalkMax);
    walkInterval = 60000/walkInterval;
  }
}

// ----------------------------------------------------------------------

void MainTask_Autonomous() {
  // autonomous discovery mode, stays in this mode until reset
  // starts with looking in front of itself
  // if clear, then move forward a random distance
  // if not clear, rotate and look again
  if (MainRun) {return;}
  MainRun = true; // prevent re-entry of task
  switch (SubTask) {
    case 0: // initialise
      Serial.println(F("> MainTask_Autonomous()")); 
      automRnd = 1; SubTask = 1; break;
    case 1:
      // set legs for going forward, prior to radar scanning
      automTurn = 0; Walk = 0; walkInterval = 18000; StartWalk(-1); 
      SubTask = 2; break;
    case 2:
      // twist scan and turning code
      RangeCentre = LtofMax;  RangeLeft = LtofMax; RangeRight = LtofMax;
      SetLedMode(5);
      if (random(2) < 1) {
        // twist left, then right, taking radar readings
        // twist to the left
//        Serial.println(F("Looking left...")); 
        GoToAngles(45,-1,135,-1,45,-1,135,-1,30); loopWhiletgtCnt();
        delayLoop(150); if (Range <= LtofDet) {RangeLeft = Range;}
//        Serial.println(Range); 
        // twist to the right
//        Serial.println(F("Looking right...")); 
        GoToAngles(135,-1,45,-1,135,-1,45,-1,60); loopWhiletgtCnt();
        delayLoop(150); if (Range <= LtofDet) {RangeRight = Range;}
//        Serial.println(Range); 
      } else {
        // twist right, then left, taking radar readings
        // twist to the right
//        Serial.println(F("Looking right...")); 
        GoToAngles(135,-1,45,-1,135,-1,45,-1,30); loopWhiletgtCnt();
        delayLoop(150); if (Range <= LtofDet) {RangeRight = Range;}
//        Serial.println(Range); 
        // twist to the left
//        Serial.println(F("Looking left...")); 
        GoToAngles(45,-1,135,-1,45,-1,135,-1,60); loopWhiletgtCnt();
        delayLoop(150); if (Range <= LtofDet) {RangeLeft = Range;}
//        Serial.println(Range); 
      }
      // back to centre
//      Serial.println(F("Looking forward...")); 
      GoToAngles(90,-1,90,-1,90,-1,90,-1,30); loopWhiletgtCnt();
      delayLoop(150); if (Range <= LtofDet) {RangeCentre = Range;}
//      Serial.println(Range); 


        
      // now check range readings and respond
      if (automTurn == 0) {
        // haven't just turned, so determine direction
        if (RangeLeft <= 325) {
          // something is to my left so turn right and repeat process measurements
          automRnd = 1; // reset walking to short distance at first
          if (RangeRight > RangeLeft) {
            // object on the left is closer
            SetLedMode(2);
            // TurnRight(zAng,zStep1,zSpeed)
  //          Serial.println(F("Turning Right...")); 
            TurnRight(60,10,8); automTurn = 1; loopWhiletgtCnt();
          } else {
            // object on the right is closer
            SetLedMode(4);
            // TurnLeft(zAng,zStep1,zSpeed)
  //          Serial.println(F("Turning Left...")); 
            TurnLeft(60,10,8); automTurn = -1; loopWhiletgtCnt();
          } break;
        }
        else if (RangeRight <= 325) {
          // something is to my right so turn left and repeat process measurements
          automRnd = 1; // reset walking to short distance at first
          if (RangeLeft > RangeRight) {
            // object on the right is closer
            SetLedMode(4);
            // TurnLeft(zAng,zStep1,zSpeed)
  //          Serial.println(F("Turning Left...")); 
            TurnLeft(60,10,8); automTurn = -1; loopWhiletgtCnt();
          } else {
            // object on the left is closer
            SetLedMode(2);
            // TurnRight(zAng,zStep1,zSpeed)
  //          Serial.println(F("Turning Right...")); 
            TurnRight(60,10,8); automTurn = 1; loopWhiletgtCnt();
          } break;
        }
        else if (RangeCentre <= 325) {
          // something is in front of me, but sides are clear
          // so turn randomly left/right
  //        Serial.println(F("Object ahead...")); 
          automRnd = 1; // reset walking to short distance at first
          if (random(2) > 0) {
  //          Serial.println(F("Turning Left...")); 
            SetLedMode(4);
            TurnLeft(90,10,8); automTurn = -1; loopWhiletgtCnt(); break;
          } else {
  //          Serial.println(F("Turning Right...")); 
            SetLedMode(2);
            TurnRight(90,10,8); automTurn = 1; loopWhiletgtCnt(); break;
          }
        } 
        else {SubTask = 3; break;}
      }
      else if ((RangeCentre <= 325) || (RangeLeft <= 325) || (RangeRight <= 325)) {
        // despite turning an object has still been detected
        // so we continue turning in the same direction
        automRnd = 1; // reset walking to short distance at first
        if  (automTurn > 0) {
          // just turned to the right, so continue turning if object is present
          SetLedMode(2);
          TurnRight(60,10,6); loopWhiletgtCnt();
        } else {
          // just turned to the left, so continue turning if object is present
          SetLedMode(4);
          TurnLeft(60,10,6); loopWhiletgtCnt();
        }
      }
      else {SubTask = 3; break;}




      
      case 3:
        // all is clear so walk for a random distance, then re-measure
        // random distance increases provided nothing is detected along the way
//        Serial.println(F("Walking forward..."));
        walkInterval = 15000 + (1000 * random(7)); // vary walking speed
        StartWalk(1); SetLedMode(1);
//        loopWhileWalkEcho(88 * (1 + random(automRnd)));
        loopWhileWalkEcho(88 * automRnd);
        if (automRnd < 10) {automRnd++;} // increase walking range
        delayLoop(200); // short pause before range scanning
        SubTask = 1; // restart scanning process
        break;

  } MainRun = false;
}

// ----------------------------------------------------------------------

void MainTask_TrackWall(int zMode) {
  // dual function depending on zMode value
  // zMode = 0 backs away from an approaching target
  // zMode = 1 maintains a fixed distance from a wall, stays in this mode until reset
  if (MainRun) {return;}
  MainRun = true; // prevent re-entry of task
  switch (SubTask) {
    case 0: // initialise
      R0 = 55; RM = 335; Walked = 0;
      if (zMode == 0) {
        Serial.println(F("> MainTask_BackAway()"));
        R1 = 124; R2 = 180; R3 = 325;
      } else {
        Serial.println(F("> MainTask_TrackWall()"));
        R1 = 89; R2 = 117; R3 = 189; R4 = 225; R5 = 298; R6 = 325;
      } SubTask = 1; break;
    case 1:
      // depending on zMode set a walk direction
      if (zMode == 0) {
        // start expecting to go backward
        StartWalk(-3);
      } else {
        // start expecting to go forward
        StartWalk(-1);
      }
      SubTask = 2; break;
    case 2: // wait for a wall to appear and if necessary change direction
      // only move onto SubTask 3 when a wall appears
      walkInterval = 60000; 
//      Serial.println(Walk);
      if ((Range >= R0) && (Range <= R3)) {
        SubTask = 3; Walk= abs(Walk);
        if (Walk != 3) {
          // change walk direction from forwards to backwards
          Walk = 0; WalkCnt += 44; if (WalkCnt > 87) {WalkCnt -= 88;}
          WalkNext = 3; SetLegStates(); // set leg heights
          SubTask = 99;
        }
      } else if ((Range >= R4) && (Range <= R6)) {
        SubTask = 3; Walk= abs(Walk);
        if (Walk != 1) {
          // change walk direction from backards to forwards
          Walk = 0; WalkCnt -= 44; if (WalkCnt < 0) {WalkCnt += 88;}
          WalkNext = 1; SetLegStates(); // set leg heights
          SubTask = 99;
        }
      } break;
    case 3: // scan for wall and respond
      if (Range >= R0) {
        if (Range > RM) {
          // target moved out of range so stop
          SubTask = 4;
        } else if ((zMode > 0) && (Range > R6)) {
          // if walking forward let it continue, but if not start; both moderately
          if (abs(Walk) == 1) {Walk = 1;}
          else {StartWalk(1);} walkInterval = 20000; LedMode = 1;
        } else if ((zMode > 0) && (Range >= R4) && (Range <= R6)) {
          // far wall detected so walking speed depends on how close it is
          walkInterval = map(Range, R4,R5,1,12);
          walkInterval = 60000/walkInterval;
          if (Range >= R5) {walkInterval = 5000;} // cap minimum interval
          Walk = 1; LedMode = 1;
        } else if ((Range <= R3) && (Range >= R1)) {
          // close wall detected so backaway speed depends on how close it is
          walkInterval = map(Range,R3,R2,1,12);
          walkInterval = 60000/walkInterval;
          if (Range <= R2) {walkInterval = 5000;} // cap minimum interval
          Walk = 3; LedMode = 3;
        } else if (Range < R1) {
          // too close wall detected so slow down backaway speed
          walkInterval = map(Range, R0,R1,1,12);
          walkInterval = 60000/walkInterval;
          Walk = 3; LedMode = 3;
        } else {
          // in centre deadband so stop
          SubTask = 4;}
      } else {
        // no wall detected but one had been previously
        SubTask = 4;
      } break;
    case 4: // stop moving and put feet down and wait
      Walk = -abs(Walk); walkInterval = 20000; LedMode = 0;
      MemStore(); // store current values
      GoToAngles(-1,LegDn,-1,LegDn,-1,LegDn,-1,LegDn,1); // put all feet down immediately
      SubTask++; anyMilli = millis(); break;
    case 5: // wait for a valid range then return to previous movement
      if ((Range >= R0) && (Range <= R3)) {
        // valid reverse range
        if (Walk == -3) {
          // previously walking backwards so raise lowered legs and continue
          MemRead(); tgtCnt = 1; SubTask = 3;
        } else {SubTask = 2;} // walking direction changing
      } else if ((zMode > 0) && (Range >= R4) && (Range <= R6)) {
        // valid forward range
        if (Walk == -1) {
          // previously walking forwards so lower legs and continue
          MemRead(); tgtCnt = 1; SubTask = 3;
        } else {SubTask = 2;} // walking direction changing
      }
      if (zMode == 0) {
        // check after a delay to see if a return movemnent is needed
        if ((millis() - anyMilli) >= 5000) {
          if (Walked < -44) {SubTask++;} // at least half a stride backwards
          else {anyMilli = millis();}
        }
      } break;
    case 6:
      walkInterval = 20000;
      Walk = 0; WalkCnt -= 44; if (WalkCnt < 0) {WalkCnt += 88;}
      SetLegStates(); // set leg heights
      LedMode = 1; SubTask++; break;
    case 7:
      // change direction of walk movement to forward
      walkInterval = 40000; Walk = 1;
      SubTask++; break;
    case 8: // reached beginning or seen another wall
//      Serial.print(F("Walked = ")); Serial.println(Walked);
      if (((Range >= R0) && (Range <= R3)) || (Walked >= -1)) {
        Walk = 0; SubTask = 1; LedMode = 0;
        GoToAngles(-1,LegDn,-1,LegDn,-1,LegDn,-1,LegDn,1);
      }
      // if approaching start point slow down
      if (Walked > -100) {if (walkInterval < 40000) {walkInterval += 200;}}
      else if (walkInterval > 10000) {walkInterval -= 100;}
      break;
    case 99:
      // one cycle to allow leg heights to be set before moving
      Walk = WalkNext; SubTask = 3; break;
  } MainRun = false;
}

// ----------------------------------------------------------------------

void MoveToAngles(int zA1,int zA2,int zA3,int zA4,int zA5,int zA6,int zA7,int zA8) {
  // move to specific servo angles by raising and lowering legs
  // number of 20ms steps in movement set by zCnt
  if (ESC) return; // exit if this flag is set
  if (!servoEn) {attachServos(0);}
  anyDel = 120;
  GoToAngles(-1,LegDn,-1,LegDn,-1,LegDn,-1,LegDn,3); loopWhiletgtCnt();
  SetAngle(10,zA1); // get the target angle in microseconds, but don't move the servo
  if (servoVal[0] != servoTgt[0]) {
    SetAngle(1,LegUp); delayLoop(anyDel); SetAngle(0,zA1); delayLoop(anyDel);
  } SetAngle(1,zA2);
  SetAngle(12,zA3); // get the target angle in microseconds, but don't move the servo
  if (servoVal[2] != servoTgt[2]) {
    SetAngle(3,LegUp); delayLoop(anyDel); SetAngle(2,zA3); delayLoop(anyDel);
  } SetAngle(3,zA4);
  SetAngle(14,zA5); // get the target angle in microseconds, but don't move the servo
  if (servoVal[4] != servoTgt[4]) {
    SetAngle(5,LegUp); delayLoop(anyDel); SetAngle(4,zA5); delayLoop(anyDel);
  } SetAngle(5,zA6);
  SetAngle(16,zA7); // get the target angle in microseconds, but don't move the servo
  if (servoVal[6] != servoTgt[6]) {
    SetAngle(7,LegUp); delayLoop(anyDel); SetAngle(6,zA7); delayLoop(anyDel);
  } SetAngle(7,zA8);  delayLoop(anyDel);
  if (autoOFF >= 0) {autoOFF = 5;} // set auto-OFF timeout
}

// ----------------------------------------------------------------------

void SetLegStates() {
  // set leg heights depending on WalkCnt, used when reversing direction
  LegSt1 = LegDn; LegSt3 = LegDn; LegSt5 = LegDn; LegSt7 = LegDn;
  if ((WalkCnt > 1) && (WalkCnt < 44)) {LegSt3 = LegUp; LegSt7 = LegUp;}
  else if (WalkCnt > 45) {LegSt1 = LegUp; LegSt5 = LegUp;}
  GoToAngles(-1,LegSt1,-1,LegSt3,-1,LegSt5,-1,LegSt7,1);
}

// ----------------------------------------------------------------------

void SetLegsDown() {
  // stores the leg positions then puts them all down on the floor
  MemStore();
  SetAngle(1,LegDn); SetAngle(3,LegDn); SetAngle(5,LegDn); SetAngle(7,LegDn);
}

// ----------------------------------------------------------------------

void SetLegsPrevious() {
  // recover stored leg positions
  MemRead(); SetToTgtNow();
}

// ----------------------------------------------------------------------

void StartWalk(int zWalk) {
  // initiates one of four walk directions
  // if zWalk is -ve then position feet but don't walk
  // 0 - stationary
  // 1 - walk forward
  // 2 - walk to the right
  // 3 - walk backwards
  // 4 - walk to the left
  // 5 - turn to the left
  // 6 - turn to the right
  Walk = 0; WalkCnt = 21; // stop walking and set start points
  switch (abs(zWalk)) {
    case 0: MoveToAngles(111,LegDn,112,LegDn,114,LegDn,113,LegDn); break;
    case 1: MoveToAngles(111,LegDn,112,LegDn,114,LegDn,113,LegDn); break;
    case 2: MoveToAngles(67,LegDn,69,LegDn,68,LegDn,66,LegDn); break;
    case 3: MoveToAngles(114,LegDn,113,LegDn,111,LegDn,112,LegDn); break;
    case 4: MoveToAngles(68,LegDn,66,LegDn,67,LegDn,69,LegDn); break;
    case 5: MoveToAngles(69,LegDn,67,LegDn,69,LegDn,67,LegDn); break;
    case 6: MoveToAngles(67,LegDn,69,LegDn,67,LegDn,69,LegDn); break;
  }
  Walk = zWalk; // start walking if Walk > 0
  if (zWalk >= 0) {
    SetLedMode(Walk);
  }
}
// ----------------------------------------------------------------------

void TurnLeft(int zAng, int zStep, int zCnt) {
  // neutral turn to the left by a given angle, step and speed
  // note that speed can also be set by walkInterval loop period
  // zStep should be >= 1 and <= 45
  // the actual angle turned is approximately (zAng * 28)/45
  // if zAng < 0 then don't move legs to the drop position, assume already there
  int zSwg; zStep = max(zStep,1); zStep = min(zStep,45); // ensure zStep is in range
//  Serial.print(F("> TurnRight(")); Serial.print(zAng); Serial.println(F(")"));
//  GoToAngles(90,LegDn,90,LegDn,90,LegDn,90,LegDn,zCnt); loopWhiletgtCnt(); // drop to move angle
  MoveToAngles(90,LegDn,90,LegDn,90,LegDn,90,LegDn); loopWhiletgtCnt(); // drop to move angle
  SetLedMode(4);
  while (zAng > 0) {
    // move a max of 10 degrees on each opposite leg set at a time
    // FL and RR legs first
    if (Turn) {zSwg = zStep; zAng = zStep;} // turning continuously
    else {zSwg = min(zAng,zStep); zAng = zAng - zSwg;} // turning through an angle
    GoToAngles(-1,LegUp,-1,-1,-1,LegUp,-1,-1,3); loopWhiletgtCnt(); // raise FL RR legs quickly
    delayLoop(2);
    GoToAngles(90+zSwg,-1,-1,-1,90+zSwg,-1,-1,-1,zCnt); loopWhiletgtCnt(); // swing legs quickly
    delayLoop(2);
    GoToAngles(-1,LegDn,-1,-1,-1,LegDn,-1,-1,3); loopWhiletgtCnt(); // drop legs quickly
    delayLoop(2);
    GoToAngles(-1,-1,-1,LegUp,-1,-1,-1,LegUp,3); loopWhiletgtCnt(); // raise legs quickly
    delayLoop(2);
    GoToAngles(90,-1,-1,-1,90,-1,-1,-1,zCnt); loopWhiletgtCnt(); // swing legs quickly
    delayLoop(2);
    if (zAng < 1) {GoToAngles(-1,-1,-1,LegDn,-1,-1,-1,LegDn,3); loopWhiletgtCnt(); // drop legs quickly
      delayLoop(2);}
    else {
      if (Turn) {zSwg = zStep; zAng = zStep;} // turning continuously
      else {zSwg = min(zAng,zStep); zAng = zAng - zSwg;} // turning through an angle
      // FR and RL legs
      GoToAngles(-1,-1,-1,LegUp,-1,-1,-1,LegUp,3); loopWhiletgtCnt(); // raise FR RL legs quickly
      delayLoop(2);
      GoToAngles(-1,-1,90-zSwg,-1,-1,-1,90-zSwg,-1,zCnt); loopWhiletgtCnt(); // swing legs quickly
      delayLoop(2);
      GoToAngles(-1,-1,-1,LegDn,-1,-1,-1,LegDn,3); loopWhiletgtCnt(); // drop legs quickly
      delayLoop(2);
      GoToAngles(-1,LegUp,-1,-1,-1,LegUp,-1,-1,3); loopWhiletgtCnt(); // raise legs quickly
      delayLoop(2);
      GoToAngles(-1,-1,90,-1,-1,-1,90,-1,zCnt); loopWhiletgtCnt(); // swing legs quickly
      delayLoop(2);
      if (zAng < 1) {GoToAngles(-1,LegDn,-1,-1,-1,LegDn,-1,-1,3); loopWhiletgtCnt(); // drop legs quickly
        delayLoop(2);}
    }
  } SetLedMode(0);
}

// ----------------------------------------------------------------------

void TurnRight(int zAng, int zStep, int zCnt) {
  // neutral turn to the right by a given angle, step and speed
  // note that speed can also be set by walkInterval loop period
  // zStep should be >= 1 and <= 45
  // the actual angle turned is approximately (zAng * 28)/45
  // if zAng < 0 then don't move legs to the drop position, assume already there
  int zSwg; zStep = max(zStep,1); zStep = min(zStep,45); // ensure zStep is in range
//  Serial.print(F("> TurnRight(")); Serial.print(zAng); Serial.println(F(")"));
//  GoToAngles(90,LegDn,90,LegDn,90,LegDn,90,LegDn,zCnt); loopWhiletgtCnt(); // drop to move angle
  MoveToAngles(90,LegDn,90,LegDn,90,LegDn,90,LegDn); loopWhiletgtCnt(); // drop to move angle
  SetLedMode(2);
  while (zAng > 0) {
    // move a max of 10 degrees on each opposite leg set at a time
    // FR and RL legs first
    if (Turn) {zSwg = zStep; zAng = zStep;} // turning continuously
    else {zSwg = min(zAng,zStep); zAng = zAng - zSwg;} // turning through an angle
    GoToAngles(-1,-1,-1,LegUp,-1,-1,-1,LegUp,3); loopWhiletgtCnt(); // raise FR RL legs quickly
    delayLoop(2);
    GoToAngles(-1,-1,90+zSwg,-1,-1,-1,90+zSwg,-1,zCnt); loopWhiletgtCnt(); // swing legs quickly
    delayLoop(2);
    GoToAngles(-1,-1,-1,LegDn,-1,-1,-1,LegDn,3); loopWhiletgtCnt(); // drop legs quickly
    delayLoop(2);
    GoToAngles(-1,LegUp,-1,-1,-1,LegUp,-1,-1,3); loopWhiletgtCnt(); // raise legs quickly
    delayLoop(2);
    GoToAngles(-1,-1,90,-1,-1,-1,90,-1,zCnt); loopWhiletgtCnt(); // swing legs quickly
    delayLoop(2);
    if (zAng < 1) {GoToAngles(-1,LegDn,-1,-1,-1,LegDn,-1,-1,3); loopWhiletgtCnt(); // drop legs quickly
      delayLoop(2);}
    else {
      if (Turn) {zSwg = zStep; zAng = zStep;} // turning continuously
      else {zSwg = min(zAng,zStep); zAng = zAng - zSwg;} // turning through an angle
      // FL and RR legs
      GoToAngles(-1,LegUp,-1,-1,-1,LegUp,-1,-1,3); loopWhiletgtCnt(); // raise FL RR legs quickly
      delayLoop(2);
      GoToAngles(90-zSwg,-1,-1,-1,90-zSwg,-1,-1,-1,zCnt); loopWhiletgtCnt(); // swing legs quickly
      delayLoop(2);
      GoToAngles(-1,LegDn,-1,-1,-1,LegDn,-1,-1,3); loopWhiletgtCnt(); // drop legs quickly
      delayLoop(2);
      GoToAngles(-1,-1,-1,LegUp,-1,-1,-1,LegUp,3); loopWhiletgtCnt(); // raise legs quickly
      delayLoop(2);
      GoToAngles(90,-1,-1,-1,90,-1,-1,-1,zCnt); loopWhiletgtCnt(); // swing legs quickly
      delayLoop(2);
      if (zAng < 1) {GoToAngles(-1,-1,-1,LegDn,-1,-1,-1,LegDn,3); loopWhiletgtCnt(); // drop legs quickly
        delayLoop(2);}
    }
  } SetLedMode(0);
}

// ----------------------------------------------------------------------



